#pragma once

#include "TgraphicsObject.h"

class TgeometryComponent : public TgraphicsObject {
	
	protected:
		D3DXVECTOR3		fRefPosition;		// reference position

		TgraphicsObject	*fGeometryComponent;	
							// This is the object that will behave like a component

							// from TgraphicsObject ...
		virtual	void	DrawObjectGeom(Td3dDrawable&, LPDIRECT3DDEVICE9);

	public:
							// from TgraphicsObject ...
		virtual	void	SetObjectD3DTransformation(ID3DXMatrixStack *stack) const;

		virtual ~TgeometryComponent();
		TgeometryComponent(TgraphicsObject *geom, const D3DXVECTOR3 &ref);

		void SetReferencePosition(const D3DXVECTOR3 &p) { fRefPosition = p; }
		const D3DXVECTOR3& GetReferencePosition() const { return fRefPosition; }
};
