// TtextureControl.cpp : implementation file
//

#include "StdAfx.h"
#include "ClassExample.h"
#include "TtextureControl.h"

#include "GraphicsAPI/GraphicsAPI.h"
#include "Td3dDrawable.h"

#include "Model/Tworld.h"


/////////////////////////////////////////////////////////////////////////////
// TtextureControl dialog


TtextureControl::TtextureControl(CWnd* pParent /*=NULL*/)
	: CDialog(TtextureControl::IDD, pParent)
	, m_TextureIndexEcho(_T(""))

{
	m_TextureEnabled = false;
	m_TransparencyEnabled = false;
}


void TtextureControl::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TEXTURE_INDEX, m_TextureIndexSlider);
	
	DDX_Text(pDX, IDC_TEXTURE_INDEX_ECHO, m_TextureIndexEcho);

	DDX_Check(pDX, IDC_ENABLE_TEXTURE, m_TextureEnabled);
	DDX_Check(pDX, IDC_ENABLE_TRANSPARENCY, m_TransparencyEnabled);
}


BEGIN_MESSAGE_MAP(TtextureControl, CDialog)
	
	ON_BN_CLICKED(IDC_DRAW_CIRCLE, OnDrawCircle)
	ON_BN_CLICKED(IDC_DRAW_RECTANGLE, OnDrawRectangle)
	ON_BN_CLICKED(IDC_DRAW_NORM_RECTANGLE, OnBnClickedDrawNormRectangle)

	ON_NOTIFY(NM_CUSTOMDRAW, IDC_TEXTURE_INDEX, OnNMCustomdrawTextureIndex)
	
	ON_BN_CLICKED(IDC_ENABLE_TEXTURE, OnBnClickedEnableTexture)
	ON_BN_CLICKED(IDC_ENABLE_TRANSPARENCY, OnBnClickedEnableTransparency)

	ON_BN_CLICKED(IDC_DRAW_TEXTURE, OnBnClickedDrawTexture)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// TtextureControl message handlers


BOOL TtextureControl::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_TextureIndexSlider.InitializeSliderWithEcho(&m_TextureIndexEcho, 0, 10, 0, 10);

	CheckRadioButton(IDC_DRAW_CIRCLE, IDC_DRAW_NORM_RECTANGLE, IDC_DRAW_CIRCLE);

	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void TtextureControl::OnDrawCircle() 
{
	fWorld->SetToDrawCircle();
}

void TtextureControl::OnDrawRectangle() 
{
	fWorld->SetToDrawRectangle();
}
void TtextureControl::OnBnClickedDrawNormRectangle()
{
	fWorld->SetToDrawNormRectangle();
}


void TtextureControl::OnBnClickedEnableTexture()
{
	UpdateData(true);
	fWorld->SetTextureTo(m_TextureEnabled);
}

void TtextureControl::OnBnClickedEnableTransparency()
{
	UpdateData(true);
	fWorld->SetTransparencyTo(m_TransparencyEnabled);
}

void TtextureControl::OnNMCustomdrawTextureIndex(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: Add your control notification handler code here
	*pResult = 0;

	fWorld->SetTextureIndexTo(int(m_TextureIndexSlider.GetSliderValue()));
	m_TextureIndexSlider.UpdateSliderEcho();
	UpdateData(false);
}

void TtextureControl::OnBnClickedDrawTexture()
{
	fWorld->DrawOnTexture();
}